org.apache.hc.core5.http.nio

## Interface AsyncDataProducer

- All Superinterfaces:
    ResourceHolder
  All Known Subinterfaces:
    AsyncClientExchangeHandler, AsyncDataExchangeHandler, AsyncEntityProducer, AsyncPushProducer, AsyncRequestProducer, AsyncResponseProducer, AsyncServerExchangeHandler
  All Known Implementing Classes:
    AbstractBinAsyncEntityProducer, AbstractCharAsyncEntityProducer, AbstractClassicEntityProducer, AbstractClassicServerExchangeHandler, AbstractServerExchangeHandler, AsyncEntityProducerWrapper, BasicAsyncEntityProducer, BasicAsyncServerExpectationDecorator, BasicClientExchangeHandler, BasicPushProducer, BasicRequestProducer, BasicResponseProducer, BasicServerExchangeHandler, DigestingEntityProducer, FileEntityProducer, ImmediateResponseExchangeHandler, PathEntityProducer, ReactiveEntityProducer, ReactiveServerExchangeHandler, StringAsyncEntityProducer

      public interface AsyncDataProducer
      extends ResourceHolder

  Abstract asynchronous data producer.
  Since:
    5.0

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()` Returns the number of bytes immediately available for output.
    `void` | `produce(DataStreamChannel channel)` Triggered to signal the ability of the underlying data channel to accept more data.

    - ### Methods inherited from interface org.apache.hc.core5.http.nio.ResourceHolder

      `releaseResources`

- - ### Method Detail

    - #### available

          int available()

      Returns the number of bytes immediately available for output. This method can be used as a hint to control output events of the underlying I/O session.
      Returns:
        the number of bytes immediately available for output

    - #### produce

          void produce(DataStreamChannel channel)
                throws IOException

      Triggered to signal the ability of the underlying data channel to accept more data. The data producer can choose to write data immediately inside the call or asynchronously at some later point.
      Parameters:
        `channel` - the data channel capable to accepting more data.
      Throws:
        `IOException`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.